float gravity = 0.8;
 
 /* Bouncing balls without OO by Loe Feijs @TU/e december 2013
  * Modified version of code on "Bouncing colliding balls" by
  * Angel Andrés, http://www.openprocessing.org/sketch/56261
  * Note: Coefficient of resititution is made 1, so elastic movements
  */
  
  int N = 10;//how many balls
  
  float[] posX = new float[N];
  float[] posY = new float[N];
  float[] dirX = new float[N];
  float[] dirY = new float[N];
  float[] radi = new float[N];
  float[] mass = new float[N];
  int R[] = new int[N];
  int G[] = new int[N];
  int B[] = new int[N];
  
void setup() {
  size (800, 450);
  background(30);
  frameRate(10);

  for (int i = 0; i<N; i++) {
       posX[i] = random(width);
       posY[i] = random(height);
       dirX[i] = random(10);
       dirY[i] = random(10);
       radi[i] = int(random(5,15));
       mass[i] = 3.14159 * radi[i] * radi[i];
       R[i] = int(random(255));
       G[i] = int(random(255));
       B[i] = int(random(255));
  }
}
 
void draw () {
  background(30);
  for (int i = 0; i<N; i++) {
       newVelocity(i);
       newPosition(i);
  }
}
 

void newPosition(int i){
    posX[i] += dirX[i];
    posY[i] += dirY[i];
     
    fill (R[i], G[i], B[i]);
    ellipse (posX[i], posY[i], 2*radi[i], 2*radi[i]);
     
    if (posX[i] >= width) {dirX[i] = -dirX[i];}
    if (posX[i] <= 0) {dirX[i] = -dirX[i];}
     
    if (posY[i] > height - radi[i]) {
        dirY[i] = -abs(dirY[i]);
        if (abs(dirY[i]) < 1) {
            dirY[i] = 0;
        }
        posY[i] = height - radi[i];
    }
}
  

boolean collision(int i, int j){
    float dd, rr;
    dd = dist(posX[i],posY[i], posX[j], posY[j]);
    rr = radi[i] + radi[j];
    if (i != j && dd < rr)
        return true;
    else return false;
}

void newVelocity(int j) {
  float ui, uj, vi, vj;
  for (int i = 0; i < N; i++) {
       if (collision(i,j)){
          //Calculate new velocity
          ui = dirX[i];
          uj = dirX[j];         
          dirX[i] = (mass[j]*(uj-ui) + mass[i]*ui + mass[j]*uj)/( mass[i] + mass[j]);
          dirX[j] = (mass[i]*(ui-uj) + mass[i]*ui + mass[j]*uj)/( mass[i] + mass[j]);
          ui = dirY[i];
          uj = dirY[j];         
          dirY[i] = (mass[j]*(uj-ui) + mass[i]*ui + mass[j]*uj)/( mass[i] + mass[j]);
          dirY[j] = (mass[i]*(ui-uj) + mass[i]*ui + mass[j]*uj)/( mass[i] + mass[j]);
      }
  }
  dirY[j] = dirY[j] + gravity;
}

/* V1(after) = ((M1 - M1)/(M1+M2))*V1 + (2*M2/(M1+M2))/V2
 * V2(after) = (2M1/(M1+M2))*V1 + ((M1-M2)/(M1+M2))*V2
 * http://amrita.vlab.co.in/?sub=1&brch=74&sim=189&cnt=1
 * based on solving preservation of sum of impulses
 * M1V1 + M2V2 = M1V1(after) + M2V2(after)
 * and preservation of kinetic energy
 * ½M1(V1)²+½M2(V2)²=½M1(V1(after))²+½M2(V2(after))²
 * here they appear slightly rewritten:
 * V1(after) = (M2V2 - M2V1 + M1V1 + M2V2)/(M1+M2)
 * where i plays 1, j plays 2, and (dirX,dirY) plays V
*/

