/*
** Moving cirles, a demo program how the viewer can be fooled to believe a fluid motion is 
** displayed with simple graphic elements and motion
**
** Author: P.Peters
** September 1, 2015
*/

int screenSize = 200;          // size of the dispay canvas, width and height are the same
int circleSize = screenSize/4; // size of the moving circles
int leftPos = screenSize/4;    // leftmost position of circles
int topPos = screenSize/4;     // topmost position of circles 
int shiftMax = screenSize/2;   // max amount of distance moved
int shift = 0;                 // current amount of distance moved

void setup() {
  // setup canvas
  size(screenSize,screenSize);
  // no variables to initialize, all initialization done at declaration
}

void draw() {
  // restore background each frame
  background(175);   
  // draw ellipses
  // calculations done here are to
  // 1 - adjust the shift of each ellipse
  // 2 - kind of get the 4 ellipses in the window center
  ellipse(leftPos+shift,topPos,circleSize,circleSize); 
  ellipse(leftPos+shiftMax,topPos+shift,circleSize,circleSize);
  ellipse(leftPos+shiftMax-shift,topPos+shiftMax,circleSize,circleSize);
  ellipse(leftPos, topPos+shiftMax-shift,circleSize,circleSize);
  // increment shift count
  shift++;
  // until maximum shift reached  
  if (shift > shiftMax) { 
    shift = 0; 
  }              
}
