/*
** Stresstest, a demo program showing a sort of  stroop test. Words indicating colors are shown
** while the actual color of the word on screen might not match the color the word indicates.
** Lots of randomized stuff in here
**
** Author: P.Peters
** September 1, 2015
*/

// An array of Strings holding the color names displayed
String colorNames[] ={"red","green","blue","yellow","purple"};
// An array of colors (matching the colors indicated by the array elements of "colornames" aove
color colors[] = {color(255,0,0), color(0,255,0),color(0,0,255),color(255,255,0), color(255,0,255)};

int dly = 800; // A decreasing delay is used to speed up displaying different words/colors
int sqz = 400; // The size of the (square) canvas
int currentColor = 0; // used to index in the colornames array

void setup() {
  // setup the canvas
  size(sqz,sqz);
}

void draw() {  
  background(127);    // background is grey
  // generate a random color to use for displaying the next word
  // the random value generated is a whole number between 0 and the length of the array holding the colornames
  int randomColorName = int(random(0,colorNames.length));
  // set the color to use when drawing the text
  fill(colors[currentColor]);
  // pick next color for next time
  currentColor = currentColor + 1;
  // if this would be out of range, restart the count
  if (currentColor > colors.length-1) currentColor =  0;
  // set a random text size between 30 and 70 pixels
  textSize(random(30,70));
  // define the x and y position to display the text
  // we try to have the whole word on the screen, so we need to take the length and size
  // of the text into account. This is not the perfect way to do it, but it will do for now
  float rx = random(10+textWidth(colorNames[randomColorName]),sqz-textWidth(colorNames[randomColorName])-10);
  float ry = random(10+textWidth(colorNames[randomColorName]),sqz-textWidth(colorNames[randomColorName])-10);
  // move the canvas origin to (rx,ry)
  translate(rx,ry);
  // rotate the canvas a random number between 0 and 4 times 90 degrees
  rotate(int(random(0,4))*radians(90));
  // and display the word
  text(colorNames[randomColorName],0,0);
  // now wait a bit
  delay(dly);
  // next time wait a bit less, but don't count down to a too small delay
  if (dly > 400) dly -= 10;
}
